#include <iostream>
#include <vector>
#include <map>
#include <deque>
#include <string>
#include <set>

using namespace std;

typedef pair<int, int> edge;

edge make_edge (int u, int v) {
  return make_pair(min(u, v), max(u, v));
}

const int maxn = 1005;
set<int> adj [maxn];
vector<int> eulerian_walk;
/* algoritm euleri tsükli leidmiseks */
void dfs (int vertex) {
  while (!adj[vertex].empty()) {
    int nxt = *adj[vertex].begin();
    adj[vertex].erase(nxt);
    adj[nxt].erase(vertex);
    dfs(nxt);
    eulerian_walk.push_back(vertex);
  }
}


int main () {
  int vertexc, edgec;
  cin >> vertexc >> edgec;

  vector<edge> edges;
  for (int i = 0; i < edgec; i++) {
    int u, v;
    cin >> u >> v;

    adj[u].insert(v);
    adj[v].insert(u);
    edges.push_back(make_edge(u, v));
  }

  dfs(1);

  map<edge, string> colors;
  for (int i = 0; i < (int) eulerian_walk.size(); i++) {
    cerr << eulerian_walk[i] << " ";
    string ans;
    if (i % 2 == 0) {
      ans = "sinine";
    } else {
      ans = "punane";
    }

    colors[make_edge(eulerian_walk[i], eulerian_walk[(i + 1) % (int) eulerian_walk.size()])] = ans;
  }
  cerr << endl;

  for (edge e : edges) {
    cout << colors[e] << '\n';
  }
}
