#include <iostream>
#include <map>
#include <vector>

using namespace std;

const int maxn = 1005;

typedef pair<int, int> edge;
edge make_edge (int u, int v) {
  return make_pair(min(u, v), max(u, v));
}

map<edge, string> color;
int vis [maxn];
vector<int> adj [maxn];
void dfs (int vertex, int col) {
  vis[vertex] = 1;
  for (int nxt : adj[vertex]) {
    if (!vis[nxt]) {
      if (col == 1) {
        color[make_edge(vertex, nxt)] = "sinine";
      } else {
        color[make_edge(vertex, nxt)] = "punane";
      }
      dfs(nxt, -col);
    }
  }
}

const int magic [9] = {1, 2, 3, 537, 64, 103, 4, 5, 6};

int main () {
  int vertexc, edgec;
  cin >> vertexc >> edgec;

  vector<edge> edges;
  for (int i = 0; i < edgec; i++) {
    int u, v;
    cin >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
    edges.push_back(make_edge(u, v));
  }
  
  for (int i = 0; i < 8; i++) {
    color[make_edge(magic[i], magic[i + 1])] = (i % 2 == 0 ? "punane" : "sinine");
  }
  color[make_edge(1, 3)] = "sinine";
  color[make_edge(6, 4)] = "punane";

  for (int i = 0; i < 9; i++) {
    vis[magic[i]] = 1;
  }

  for (int i = 0; i < 9; i++) {
    dfs(magic[i], 1);
  }   
  
  for (edge e : edges) {
    if (color.count(e) == 0) {
      cout << "sinine" << '\n';
    } else {
      cout << color[e] << '\n';
    }
  }
}
