#include <iostream>
#include <vector>
#include <string>
#include <map>

using namespace std;

const int maxv = 1005;

vector<int> adj [maxv];

typedef pair<int, int> edge;
edge make_edge (int u, int v) {
  return make_pair(min(u, v), max(u, v));
}

map<edge, string> colors;
void direct_edge (int from, int to) {
  if (from % 2 == 0) {
    colors[make_edge(from, to)] = "punane";
  } else {
    colors[make_edge(from, to)] = "sinine";
  }
}

int lvl [maxv];
void dfs (int vertex, int parent) {
  lvl[vertex] = lvl[parent] + 1;
  for (int nxt : adj[vertex]) {
    if (lvl[nxt] == 0) {
      direct_edge(vertex, nxt);
      dfs(nxt, vertex);
    } else if (lvl[nxt] < lvl[vertex] && nxt != parent) {
      direct_edge(vertex, nxt);
    }
  }
}

int main (int argc, char **argv) {
  int vertexc, edgec;
  cin >> vertexc >> edgec;

  vector<edge> edges;
  for (int i = 0; i < edgec; i++) {
    int u, v;
    cin >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
    edges.push_back(make_edge(u, v));
  }

  dfs(atoi(argv[1]), 0);

  for (edge e : edges) {
    cout << colors[e] << '\n';
  }
}
