#include<iostream>
#include<vector>
#include<random>
#include<set>
using namespace std;

mt19937 randgen;
vector<pair<int, int> > edges;
set<pair<int, int> > taken;

bool add_edge(int u, int v) {
    if(v < u) {
        swap(u, v);
    }
    if(u == v || taken.count({u, v})) {
        return false;
    }
    edges.push_back({u, v});
    taken.insert({u, v});
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int seed;
    int n;
    int pathlen;
    int extra;
    
    cin >> seed >> n >> pathlen >> extra;
    randgen.seed(seed);
    
    
    cout << n << ' ' << n-1 + extra << '\n';
    
    for(int i=0; i<pathlen; i++) {
        add_edge(i+1, i+2);
    }
    
    for(int i=pathlen+1; i<n; i++) {
        add_edge(randgen() % i + 1, i+1);
    }
    
    while(extra > 0) {
        if(add_edge(randgen()%n + 1, randgen()%n + 1)) {
            extra--;
        }
    }
    
    for(auto c : edges) {
        cout << c.first << ' ' << c.second << '\n';
    }
    return 0;
}