; fasm syntax (https://flatassembler.net/)
; uses x86-64 linux specific syscalls
; otherwise portable

format ELF64 executable

define SYS_read 0
define SYS_write 1
define SYS_exit 60

segment readable executable

entry start
start:
	; read all input
	mov edi, 0
	mov rsi, iobuf
	mov rdx, 0x1210000
	mov eax, SYS_read
	syscall

	; parse lengths
	mov rax, iobuf
	mov rdi, queryc
	mov rsi, 2
	call parse_ints

	; parse ints
	mov rsi, qword [inputc]
	call parse_ints

	; parse queries
	mov rsi, qword [queryc]
	mov rdi, queries
	call parse_ints

	; transform
	mov rax, 0x80000
.layer:
	mov rdi, array
.row:
	mov rcx, rax
.run:
	mov rbx, [rdi]
	add qword [rdi+rax*8], rbx
	add rdi, 8
	dec rcx
	jnz .run
	lea rdi, [rdi+rax*8]
	cmp rdi, queries
	jnz .row
	shr rax, 1
	jnz .layer

	;xor edi, edi
	;mov eax, SYS_exit
	;syscall

	; format answers
	mov r10, 0x6666666666666667
	mov rdi, iobuf+0x1210000-1
	mov rsi, queries
	mov rax, qword [queryc]
	lea rsi, [rsi+rax*8-8]
.answer:
	mov byte [rdi], 10
	dec rdi
	mov rax, [rsi]
	mov rcx, qword [array+8*rax]
.format:
	mov rax, rcx
	imul r10
	mov rax, rcx
	sar rax, 0x3f
	sar rdx, 2
	sub rdx, rax
	lea rax, [rdx + rdx*4]
	add rax, rax
	sub rcx, rax
	add rcx, '0'
	mov byte [rdi], cl
	dec rdi
	mov rcx, rdx
	test rdx, rdx
	jnz .format

	sub rsi, 8
	cmp rsi, queries
	jae .answer
	inc rdi

	mov rdx, iobuf+0x1210000
	mov rsi, rdi
	sub rdx, rdi
	mov edi, 1
	mov eax, SYS_write
	syscall

	xor edi, edi
	mov eax, SYS_exit
	syscall

parse_ints: ; rax=input_ptr rdi=output_ptr rsi=count; ret rax=input_ptr
	lea rsi, [rdi+rsi*8]
	dec rax
.skip:
	inc rax
	movzx rbx, byte [rax]
	sub rbx, '0'
	cmp rbx, 9
	ja .skip
	xor ecx, ecx
.scan:
	inc rax
	lea rbx, [rcx*2+rbx]
	lea rcx, [rcx*8+rbx]
	movzx rbx, byte [rax]
	sub rbx, '0'
	cmp rbx, 9
	jbe .scan
	mov [rdi], rcx
	add rdi, 8
	cmp rdi, rsi
	jne .skip
	ret

align 64
segment readable writable

iobuf   rb 0x1210000
queryc  rq 1
inputc  rq 1
array   rq 0x100000
queries rq 0x100000
