import Control.Monad.ST
import Control.Monad
import Data.Array.ST
import Data.Array.Unboxed
import Data.Int
import Data.Bits

type Vec = UArray Int Int64

roundUp :: Integral n => n -> (n, n)
roundUp = aux 0 1
  where aux w m n = if n <= m then (w, m) else aux (w+1) (m+m) n

zeta :: Vec -> Vec
zeta input_xs = runSTUArray $ do
    let (w, n) = roundUp $ let (l, r) = bounds input_xs in r-l+1
    xs <- newArray (0, n-1) 0
    forM_ (assocs input_xs) $ \(i, x) -> writeArray xs i x
    forM_ (powers n) $ \m -> do
      forM_ (filter (\i -> i.&.m /= 0) [0..n-1]) $ \i -> do
        a <- readArray xs (i-m)
        b <- readArray xs i
        writeArray xs i (a+b)
    return xs
  where
    powers 0 = []
    powers n = n : powers (div n 2)

solve :: [Int] -> [Int64]
solve (xc:qc:rest) = let (xs, qs) = splitAt xc rest
                   in map (zeta (listArray (0, xc-1) $ map fromIntegral xs)  !) qs

solveStr :: String -> String
solveStr = unlines . map show . solve . map read . words

main :: IO ()
main = fmap solveStr getContents >>= putStr
